<?php

   /*
   Copyright (C) 2001
   by Justin Woods <woodsj@swau.edu>
   and David Sowder <davids@swau.edu>
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   */

   // $Id: index.php,v 1.39 2001/10/25 20:33:23 davids Exp $

   // Check the PHP version before doing anything else
   // The check seems to have to be here because webstamp.inc doesn't parse
   // under the PHP 3.x that I've tried it with
   if( floor( phpversion()) != 4 ) {
     echo "<html>\n";
     echo "<head>\n";
     echo "<title>Webstamp error</title>\n";
     echo "</head>\n";
     echo "<body bgcolor=\"#ffffff\">\n";
     echo "<center><font size=+3 color=\"#ff0000\">Webstamp error</font></center><br>\n";
     echo "The Webstamp framework currently requires PHP version 4.x<br><br>\n";
     echo "You shouldn't see this message unless you're a Webstamp website developer.<br><br>\n";
     echo "Please notify the server administrator: $SERVER_ADMIN\n";
     echo "</body>\n";
     echo "</html>\n";
     die();
     }

   // Required variable "setup" is below
   if( is_link( readlink( $SCRIPT_FILENAME ))) {
     if( is_link( readlink( readlink( $SCRIPT_FILENAME )))) {
       // **FIXME**
       echo "<html><head><title>Oops</title></head><body bgcolor=\"#ffffff\">\n
             We made a silly error somewhere and now our site is broken.<br>\n
             Perhaps you can at least get somewhere useful from the\n
             \"<a href=\"/\">Front Door</a>\"<br>\n
             <br>\n
             <p><i>url: $REQUEST_URI</i></p>\n";
       die( '' );
       }
     $RELOURDIR = dirname( dirname( readlink( $SCRIPT_FILENAME )));
     $RELROOTDIR = $RELOURDIR . '/' . dirname( dirname( dirname( readlink( readlink( $SCRIPT_FILENAME )))));
     }
   else {
     $RELOURDIR = dirname( dirname( readlink( $SCRIPT_FILENAME )));
     $RELROOTDIR = $RELOURDIR;
     }

   $OURDIR = realpath( $RELOURDIR ) . '/';
   $ROOTDIR = realpath( $RELROOTDIR ) . '/';
   $OURLIBS = $OURDIR . '.libs/';
   $ROOTLIBS = $ROOTDIR . '.libs/';
   $OURCACHE = $OURDIR . '.cache/';
   $ROOTCACHE = $ROOTDIR . '.cache/';
   $OURDATA = $OURDIR . '.data/';
   $ROOTDATA = $ROOTDIR . '.data/';
   $OURGFX = $OURDIR . '.gfx/';
   $ROOTGFX = $ROOTDIR . '.gfx/';

   include( $ROOTLIBS . 'webstamp.inc' );  // get_reldir_match_url() needed next
   $pos = strrpos( $REQUEST_URI, '?' );
   if( $pos > 0 ) {
     $CLEANER_URI = substr( $REQUEST_URI, 0, $pos );
     }
   else {
     $CLEANER_URI = $REQUEST_URI;
     }
   $pos = strrpos( $CLEANER_URI, '/' );
   if( $pos > 0 ) {
     $CLEANED_URI = substr( $CLEANER_URI, 0, $pos + 1 );
     }
   else {
     $CLEANED_URI = $CLEANER_URI;
     }
   $OURURL = get_reldir_matched_url( $RELOURDIR, $CLEANED_URI );
   $ROOTURL = get_reldir_matched_url( $RELROOTDIR, $CLEANED_URI );
   $OURGFXURL = $OURURL . '.gfx/';
   $ROOTGFXURL = $ROOTURL . '.gfx/';
   $THISURL = $CLEANED_URI;

   /*
   echo "DEBUG: THISURL: $THISURL<br>\n";
   echo "DEBUG: RELOURDIR: $RELOURDIR<br>\n";
   echo "DEBUG: OURDIR: $OURDIR<br>\n";
   echo "DEBUG: OURCACHE: $OURCACHE<br>\n";
   echo "DEBUG: OURDATA: $OURDATA<br>\n";
   echo "DEBUG: OURGFX: $OURGFX<br>\n";
   echo "DEBUG: OURLIBS: $OURLIBS<br>\n";
   echo "DEBUG: OURURL: $OURURL<br>\n";
   echo "DEBUG: OURGFXURL: $OURGFXURL<br>\n";
   echo "DEBUG: RELROOTDIR: $RELROOTDIR<br>\n";
   echo "DEBUG: ROOTDIR: $ROOTDIR<br>\n";
   echo "DEBUG: ROOTCACHE: $ROOTCACHE<br>\n";
   echo "DEBUG: ROOTDATA: $ROOTDATA<br>\n";
   echo "DEBUG: ROOTGFX: $ROOTGFX<br>\n";
   echo "DEBUG: ROOTLIBS: $ROOTLIBS<br>\n";
   echo "DEBUG: ROOTURL: $ROOTURL<br>\n";
   echo "DEBUG: ROOTGFXURL: $ROOTGFXURL<br>\n";
   */

   include( "${ROOTLIBS}siteconfig.inc" );

   //
   // Required variable "setup" is above
   // Page begins here
   //



// *************************************

   $dir_list = get_directory_steps_to_libs_dir($SCRIPT_FILENAME);

   $workingset = implode( '', file( "${OURLIBS}/^MAIN" ));

   while( list($k, $dir) = each($dir_list) ) {
      $workingset = process( $OURLIBS, $dir, $workingset, '^' );
   }
   $workingset = process( $OURLIBS, dirname($SCRIPT_FILENAME), $workingset );

   if( !isset( $unknowns )) {
     $unknowns='remove';
     }
   switch ($unknowns) {
     case "keep":
       break;
     case "remove":
       $workingset = preg_replace("/\{[^}]+\}/", "", $workingset);
       break;
     case "comment":
       $workingset = preg_replace("/\{([^}]+)\}/", "<!-- Template $varname: Variable \\1 undefined -->", $workingset);
       break;
     }

   if( $encoding = gzip_accepted($HTTP_ACCEPT_ENCODING) && $USE_COMPRESSION) {
      $gzdata = '\x1f\x8b\x08\x00\x00\x00\x00\x00'; // gzip header
      $size = strlen($workingset);
      $crc = crc32($workingset);
      $gzdata .= gzcompress($workingset, 9);
      $gzdata = substr($gzdata, 0, strlen($gzdata) - 4); // fix crc bug
      $gzdata .= pack('V',$crc) . pack('V', $size);

      Header('Content-Encoding: ' . $encoding );
      Header('Content-Length: ' . strlen($gzdata));
      echo $gzdata;
   }
   else {
      echo $workingset;
   }

?>